Imports System
Imports System.ComponentModel

Imports DevExpress.Xpo
Imports DevExpress.Data.Filtering

Imports DevExpress.ExpressApp
Imports DevExpress.Persistent.Base
Imports DevExpress.Persistent.BaseImpl
Imports DevExpress.Persistent.Validation
Public Enum eOfferAskOutState
    eInProgress = 0 'Még dolgozunk rajta
    eSent = 1 'Elküldük
End Enum
<DefaultClassOptions(), NavigationItem(False), CreatableItem(False)> _
Public Class OfferAskOut 'Kimenő ajánlatkérés fejléc
    Inherits BaseObject

    Private _CustomersFrom As CustomersFrom
    Private _Customers As Customers
    Private _Contacts As Contacts
    Private _JobNumberObjects As JobNumberObjects
    Private _DocumentNumber As String
    Private _OfferAskOutState As eOfferAskOutState

    Private _DateExecution As Date
    Private _DateValid As Date

    Private _ObjectCreated As Date
    Private _UserCreated As User

    Private _OfferAskIn As OfferAskIn

    Public Sub New(ByVal session As Session)
        MyBase.New(session)
    End Sub
    Public Overrides Sub AfterConstruction()
        MyBase.AfterConstruction()
    End Sub
    Protected Overrides Sub OnSaving()
        MyBase.OnSaving()
        If Session.IsNewObject(Me) Then
            ObjectCreated = GetSQLTime(Session)
            UserCreated = Session.GetObjectByKey(Of User)(Session.GetKeyValue(SecuritySystem.CurrentUser))
        End If
    End Sub

    Property CustomersFrom As CustomersFrom
        Get
            Return _CustomersFrom
        End Get
        Set(value As CustomersFrom)
            SetPropertyValue("CustomersFrom", _CustomersFrom, value)
        End Set
    End Property
    Property Customers As Customers
        Get
            Return _Customers
        End Get
        Set(value As Customers)
            SetPropertyValue("Customers", _Customers, value)
        End Set
    End Property
    Property Contacts As Contacts
        Get
            Return _Contacts
        End Get
        Set(value As Contacts)
            SetPropertyValue("Contacts", _Contacts, value)
        End Set
    End Property
    Property JobNumberObjects As JobNumberObjects
        Get
            Return _JobNumberObjects
        End Get
        Set(value As JobNumberObjects)
            SetPropertyValue("JobNumberObjects", _JobNumberObjects, value)
        End Set
    End Property
    Property DocumentNumber As String
        Get
            Return _DocumentNumber
        End Get
        Set(value As String)
            SetPropertyValue("DocumentNumber", _DocumentNumber, value)
        End Set
    End Property
    Property OfferAskOutState As eOfferAskOutState
        Get
            Return _OfferAskOutState
        End Get
        Set(value As eOfferAskOutState)
            SetPropertyValue("OfferAskOutState", _OfferAskOutState, value)
        End Set
    End Property

    Property DateExecution As Date
        Get
            Return _DateExecution
        End Get
        Set(value As Date)
            SetPropertyValue("DateExecution", _DateExecution, value)
        End Set
    End Property
    Property DateValid As Date
        Get
            Return _DateValid
        End Get
        Set(value As Date)
            SetPropertyValue("DateValid", _DateValid, value)
        End Set
    End Property
    <NonCloneable> _
    Property ObjectCreated As Date
        Get
            Return _ObjectCreated
        End Get
        Set(value As Date)
            SetPropertyValue("ObjectCreated", _ObjectCreated, value)
        End Set
    End Property
    <NonCloneable> _
    Property UserCreated As User
        Get
            Return _UserCreated
        End Get
        Set(value As User)
            SetPropertyValue("UserCreated", _UserCreated, value)
        End Set
    End Property

    Property OfferAskIn As OfferAskIn
        Get
            Return _OfferAskIn
        End Get
        Set(value As OfferAskIn)
            SetPropertyValue("OfferAskIn", _OfferAskIn, value)
        End Set
    End Property
    '//XPCollections

    <Association("OfferAskOut-OfferAskOutRows", GetType(OfferAskOutRows)), VisibleInListView(False), VisibleInLookupListView(False)> _
    ReadOnly Property OfferAskOutRows As XPCollection(Of OfferAskOutRows)
        Get
            Return GetCollection(Of OfferAskOutRows)("OfferAskOutRows")
        End Get
    End Property
    <Association("OfferAskOut-OfferAskOutDocuments", GetType(OfferAskOutDocuments)), VisibleInListView(False), VisibleInLookupListView(False)> _
    ReadOnly Property OfferAskOutDocuments As XPCollection(Of OfferAskOutDocuments)
        Get
            Return GetCollection(Of OfferAskOutDocuments)("OfferAskOutDocuments")
        End Get
    End Property

End Class
